using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DrivingGame
{
	/// <summary>
	/// Summary description for CarSelectionForm.
	/// </summary>
	public class CarSelectionForm : System.Windows.Forms.Form
	{
		private WorldModel  m_World;
		private string      m_OriginalCar;

		private System.Windows.Forms.Button      Button_OK;
		private System.Windows.Forms.ImageList   ImageList_Cars;
		private System.Windows.Forms.ListView    ListView_Cars;
		private System.ComponentModel.IContainer components;

		public CarSelectionForm(WorldModel m)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_World = m;

			string carname = m.Car1.GetType().ToString();
			if (carname == "DrivingGame.Car_Stock")
			{
				m_OriginalCar = ListView_Cars.Items[3].Text;
				ListView_Cars.Items[3].Selected = true;
			}
			else if (carname == "DrivingGame.Car_F1")
			{
				m_OriginalCar = ListView_Cars.Items[0].Text;
				ListView_Cars.Items[0].Selected = true;
			}
			else if (carname == "DrivingGame.Car_Humvee")
			{
				m_OriginalCar = ListView_Cars.Items[1].Text;
				ListView_Cars.Items[1].Selected = true;
			}
			else if (carname == "DrivingGame.Car_Small4by4")
			{
				m_OriginalCar = ListView_Cars.Items[2].Text;
				ListView_Cars.Items[2].Selected = true;
			}
			else if (carname == "DrivingGame.Car_Delorean")
			{
				m_OriginalCar = ListView_Cars.Items[4].Text;
				ListView_Cars.Items[4].Selected = true;
			}
			else if (carname == "DrivingGame.Car_Small")
			{
				m_OriginalCar = ListView_Cars.Items[5].Text;
				ListView_Cars.Items[5].Selected = true;
			}
			else if (carname == "DrivingGame.Car_H2")
			{
				m_OriginalCar = ListView_Cars.Items[6].Text;
				ListView_Cars.Items[6].Selected = true;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CarSelectionForm));
			System.Windows.Forms.ListViewItem listViewItem1 = new System.Windows.Forms.ListViewItem("F1", 0);
			System.Windows.Forms.ListViewItem listViewItem2 = new System.Windows.Forms.ListViewItem("Humvee", 1);
			System.Windows.Forms.ListViewItem listViewItem3 = new System.Windows.Forms.ListViewItem("Jeep", 2);
			System.Windows.Forms.ListViewItem listViewItem4 = new System.Windows.Forms.ListViewItem("Stock Car", 3);
			System.Windows.Forms.ListViewItem listViewItem5 = new System.Windows.Forms.ListViewItem("Delorean", 4);
			System.Windows.Forms.ListViewItem listViewItem6 = new System.Windows.Forms.ListViewItem("Small Car", 5);
			System.Windows.Forms.ListViewItem listViewItem7 = new System.Windows.Forms.ListViewItem("H2", 6);
			this.Button_OK = new System.Windows.Forms.Button();
			this.ImageList_Cars = new System.Windows.Forms.ImageList(this.components);
			this.ListView_Cars = new System.Windows.Forms.ListView();
			this.SuspendLayout();
			// 
			// Button_OK
			// 
			this.Button_OK.Location = new System.Drawing.Point(128, 368);
			this.Button_OK.Name = "Button_OK";
			this.Button_OK.Size = new System.Drawing.Size(96, 24);
			this.Button_OK.TabIndex = 0;
			this.Button_OK.Text = "OK";
			this.Button_OK.Click += new System.EventHandler(this.Button_OK_Click);
			// 
			// ImageList_Cars
			// 
			this.ImageList_Cars.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
			this.ImageList_Cars.ImageSize = new System.Drawing.Size(154, 146);
			this.ImageList_Cars.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ImageList_Cars.ImageStream")));
			this.ImageList_Cars.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// ListView_Cars
			// 
			this.ListView_Cars.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.ListView_Cars.HideSelection = false;
			this.ListView_Cars.Items.AddRange(new System.Windows.Forms.ListViewItem[] {
																						  listViewItem1,
																						  listViewItem2,
																						  listViewItem3,
																						  listViewItem4,
																						  listViewItem5,
																						  listViewItem6,
																						  listViewItem7});
			this.ListView_Cars.LargeImageList = this.ImageList_Cars;
			this.ListView_Cars.Location = new System.Drawing.Point(8, 8);
			this.ListView_Cars.MultiSelect = false;
			this.ListView_Cars.Name = "ListView_Cars";
			this.ListView_Cars.Size = new System.Drawing.Size(216, 352);
			this.ListView_Cars.TabIndex = 1;
			// 
			// CarSelectionForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(234, 402);
			this.Controls.Add(this.ListView_Cars);
			this.Controls.Add(this.Button_OK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "CarSelectionForm";
			this.ShowInTaskbar = false;
			this.Text = "Select a Vehicle";
			this.TopMost = true;
			this.ResumeLayout(false);

		}
		#endregion

		private void Button_OK_Click(object sender, System.EventArgs e)
		{
			string selected = ListView_Cars.SelectedItems[0].Text;

			if      (selected == ListView_Cars.Items[0].Text && selected != m_OriginalCar)
				m_World.SetCar(WorldModel.CarTypes.F1);
			else if (selected == ListView_Cars.Items[1].Text && selected != m_OriginalCar)
				m_World.SetCar(WorldModel.CarTypes.HUMVEE);
			else if (selected == ListView_Cars.Items[2].Text && selected != m_OriginalCar)
				m_World.SetCar(WorldModel.CarTypes.JEEP);
			else if (selected == ListView_Cars.Items[3].Text && selected != m_OriginalCar)
				m_World.SetCar(WorldModel.CarTypes.STOCK);
			else if (selected == ListView_Cars.Items[4].Text && selected != m_OriginalCar)
				m_World.SetCar(WorldModel.CarTypes.DELOREAN);
			else if (selected == ListView_Cars.Items[5].Text && selected != m_OriginalCar)
				m_World.SetCar(WorldModel.CarTypes.SMALLCAR);
			else if (selected == ListView_Cars.Items[6].Text && selected != m_OriginalCar)
				m_World.SetCar(WorldModel.CarTypes.H2);

			this.Close();
		}
	}
}
