using System;
using System.Collections;
using JPGL.Common;
using JPGL.Common.Primitives;
using JPGL.Math;

namespace DrivingGame
{
	/// <summary>
	/// Summary description for Car_H2.
	/// </summary>
	public class Car_H2 : Car
	{

		//-------------------------------------------------------------------------//
		public Car_H2(Ode.World w, Ode.Space s) : this(w, s, new Vector3())
		{
					
		}

		//-------------------------------------------------------------------------//
		public Car_H2(Ode.World w, Ode.Space s, Vector3 offset) : base(w, s, offset)
		{
			m_EnginePower   = 100;

			// Load and build the car model
			ArrayList ids; Geometry.LoadMultiOBJ("h2.obj", out ids);
			BuildCarModel((int)ids[0], (int)ids[3], (int)ids[2], (int)ids[1], (int)ids[4]);
			SetCarTexture("Cars\\H2.jpg");

			#region Setup Translation and Pivots for Wheels
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.X = -0.820f;
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.Y = 0;
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.Z = 1.565f;
			m_WheelFrontRight.T.P.X = -m_WheelFrontRight.T.T.X;
			m_WheelFrontRight.T.P.Y = -m_WheelFrontRight.T.T.Y;
			m_WheelFrontRight.T.P.Z = -m_WheelFrontRight.T.T.Z;

			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.X = 0.820f;
			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.Y = 0;
			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.Z = 1.565f;
			m_WheelFrontLeft.T.P.X = -m_WheelFrontLeft.T.T.X;
			m_WheelFrontLeft.T.P.Y = -m_WheelFrontLeft.T.T.Y;
			m_WheelFrontLeft.T.P.Z = -m_WheelFrontLeft.T.T.Z;

			((SceneNode)m_WheelBackRight.Children[0]).T.T.X = -0.820f;
			((SceneNode)m_WheelBackRight.Children[0]).T.T.Y = 0;
			((SceneNode)m_WheelBackRight.Children[0]).T.T.Z = -1.456f;
			m_WheelBackRight.T.P.X = -m_WheelBackRight.T.T.X;
			m_WheelBackRight.T.P.Y = -m_WheelBackRight.T.T.Y;
			m_WheelBackRight.T.P.Z = -m_WheelBackRight.T.T.Z;

			((SceneNode)m_WheelBackLeft.Children[0]).T.T.X = 0.820f;
			((SceneNode)m_WheelBackLeft.Children[0]).T.T.Y = 0;
			((SceneNode)m_WheelBackLeft.Children[0]).T.T.Z = -1.456f;
			m_WheelBackLeft.T.P.X = -m_WheelBackLeft.T.T.X;
			m_WheelBackLeft.T.P.Y = -m_WheelBackLeft.T.T.Y;
			m_WheelBackLeft.T.P.Z = -m_WheelBackLeft.T.T.Z;
			#endregion

			m_BodyPos     = new Vector3(0, 0.495f, 0);
			m_BodySize    = new Vector3(2.341f, 1.496f, 4.468f);
			m_WheelRadius = 0.44f;
			m_COGYOffset  = -0.54f;
			BuildCarDynamics(m_BodyPos, m_BodySize, m_WheelRadius);

			BuildSNHeirarchy();
		}
	}
}
