using System;
using System.Collections;
using JPGL.Common;
using JPGL.Common.Primitives;
using JPGL.Math;

namespace DrivingGame
{
	/// <summary>
	/// Summary description for Car_Police.
	/// </summary>
	public class Car_Police : Car
	{

		//-------------------------------------------------------------------------//
		public Car_Police(Ode.World w, Ode.Space s) : this(w, s, new Vector3())
		{
					
		}

		//-------------------------------------------------------------------------//
		public Car_Police(Ode.World w, Ode.Space s, Vector3 offset) : base(w, s, offset)
		{
			m_EnginePower = 55;

			// Load and build the car model
			ArrayList ids; Geometry.LoadMultiOBJ("H-Police Car-Move.obj", out ids);
			BuildCarModel((int)ids[0], (int)ids[4], (int)ids[2], (int)ids[1], (int)ids[3]);
			SetCarTexture("Cars\\policeCar.bmp");			

			#region Setup Translation and Pivots for Wheels
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.X = -0.802f;
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.Y = 0.360f;
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.Z = 1.465f;
			m_WheelFrontRight.T.P.X = -m_WheelFrontRight.T.T.X;
			m_WheelFrontRight.T.P.Y = -m_WheelFrontRight.T.T.Y;
			m_WheelFrontRight.T.P.Z = -m_WheelFrontRight.T.T.Z;

			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.X = 0.798f;
			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.Y = 0.360f;
			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.Z = 1.465f;
			m_WheelFrontLeft.T.P.X = -m_WheelFrontLeft.T.T.X;
			m_WheelFrontLeft.T.P.Y = -m_WheelFrontLeft.T.T.Y;
			m_WheelFrontLeft.T.P.Z = -m_WheelFrontLeft.T.T.Z;

			((SceneNode)m_WheelBackRight.Children[0]).T.T.X = -0.802f;
			((SceneNode)m_WheelBackRight.Children[0]).T.T.Y = 0.360f;
			((SceneNode)m_WheelBackRight.Children[0]).T.T.Z = -1.370f;
			m_WheelBackRight.T.P.X = -m_WheelBackRight.T.T.X;
			m_WheelBackRight.T.P.Y = -m_WheelBackRight.T.T.Y;
			m_WheelBackRight.T.P.Z = -m_WheelBackRight.T.T.Z;

			((SceneNode)m_WheelBackLeft.Children[0]).T.T.X = 0.798f;
			((SceneNode)m_WheelBackLeft.Children[0]).T.T.Y = 0.360f;
			((SceneNode)m_WheelBackLeft.Children[0]).T.T.Z = -1.370f;
			m_WheelBackLeft.T.P.X = -m_WheelBackLeft.T.T.X;
			m_WheelBackLeft.T.P.Y = -m_WheelBackLeft.T.T.Y;
			m_WheelBackLeft.T.P.Z = -m_WheelBackLeft.T.T.Z;
			#endregion

			m_BodyPos     = new Vector3(0, 0.965f, 0.052f);
			m_BodySize    = new Vector3(1.983f, 1.4f, 5);
			m_WheelRadius = 0.371f;
			m_COGYOffset  = -0.965f;
			m_Density     = 15;
			BuildCarDynamics(m_BodyPos, m_BodySize, m_WheelRadius);

			BuildSNHeirarchy();
		}
	}
}
