using System;
using System.Collections;
using JPGL.Common;
using JPGL.Common.Primitives;
using JPGL.Math;


namespace DrivingGame
{
	/// <summary>
	/// Summary description for Car_Small4by4.
	/// </summary>
	public class Car_Small4by4 : Car
	{
		//-------------------------------------------------------------------------//
		public Car_Small4by4(Ode.World w, Ode.Space s) : this(w, s, new Vector3())
		{
				
		}

		//-------------------------------------------------------------------------//
		public Car_Small4by4(Ode.World w, Ode.Space s, Vector3 offset) : base(w, s, offset)
		{
			// Load and build the car model
			ArrayList ids; Geometry.LoadMultiOBJ("H-Small 4x4-Move.obj", out ids);
			BuildCarModel((int)ids[0], (int)ids[2], (int)ids[1], (int)ids[3], (int)ids[4]);
			SetCarTexture("Cars\\small4x4.bmp");			

			#region Setup Translation and Pivots for Wheels
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.X = -0.75f;
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.Y = 0.38f;
			((SceneNode)m_WheelFrontRight.Children[0]).T.T.Z = 1.235f;
			m_WheelFrontRight.T.P.X = -m_WheelFrontRight.T.T.X;
			m_WheelFrontRight.T.P.Y = -m_WheelFrontRight.T.T.Y;
			m_WheelFrontRight.T.P.Z = -m_WheelFrontRight.T.T.Z;

			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.X = 0.75f;
			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.Y = 0.38f;
			((SceneNode)m_WheelFrontLeft.Children[0]).T.T.Z = 1.235f;
			m_WheelFrontLeft.T.P.X = -m_WheelFrontLeft.T.T.X;
			m_WheelFrontLeft.T.P.Y = -m_WheelFrontLeft.T.T.Y;
			m_WheelFrontLeft.T.P.Z = -m_WheelFrontLeft.T.T.Z;

			((SceneNode)m_WheelBackRight.Children[0]).T.T.X = -0.75f;
			((SceneNode)m_WheelBackRight.Children[0]).T.T.Y = 0.38f;
			((SceneNode)m_WheelBackRight.Children[0]).T.T.Z = -1.02f;
			m_WheelBackRight.T.P.X = -m_WheelBackRight.T.T.X;
			m_WheelBackRight.T.P.Y = -m_WheelBackRight.T.T.Y;
			m_WheelBackRight.T.P.Z = -m_WheelBackRight.T.T.Z;

			((SceneNode)m_WheelBackLeft.Children[0]).T.T.X = 0.75f;
			((SceneNode)m_WheelBackLeft.Children[0]).T.T.Y = 0.38f;
			((SceneNode)m_WheelBackLeft.Children[0]).T.T.Z = -1.02f;
			m_WheelBackLeft.T.P.X = -m_WheelBackLeft.T.T.X;
			m_WheelBackLeft.T.P.Y = -m_WheelBackLeft.T.T.Y;
			m_WheelBackLeft.T.P.Z = -m_WheelBackLeft.T.T.Z;
			#endregion

			m_BodyPos     = new Vector3(0, 1.155f, 0);
			m_BodySize    = new Vector3(1.966f, 1.657f, 3.652f);
			m_WheelRadius = 0.4f;
			m_Density     = 20;
			m_COGYOffset  = -0.5f;
			BuildCarDynamics(m_BodyPos, m_BodySize, m_WheelRadius);

			BuildSNHeirarchy();
		}
	}
}
