using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using JPGL.SWF;

namespace DrivingGame
{
	/// <summary>
	/// Summary description for OverviewForm.
	/// </summary>
	public class OverviewForm : System.Windows.Forms.Form
	{
		//-----------------------------------// The World
		private WorldModel m_WorldModel;
		//-----------------------------------//

		//-----------------------------------// Main Viewport/UIWindow
		private Viewport_Overview View_Overview;
		public Viewport_Overview Viewport
		{
			get { return View_Overview; }
		}
		public JPGL.SWF.UIWindow UIWindow
		{
			get { return UIWindow_Main; }
		}
		private JPGL.SWF.UIWindow UIWindow_Main;
		//-----------------------------------//
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OverviewForm(WorldModel m, JPGL.Common.Viewports.Viewport v)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_WorldModel = m;

			// Create the views
			View_Overview = new Viewport_Overview(m_WorldModel, v);
			UIWindow_Main.AttachViewport(View_Overview);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.UIWindow_Main = new JPGL.SWF.UIWindow();
			this.SuspendLayout();
			// 
			// UIWindow_Main
			// 
			this.UIWindow_Main.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.UIWindow_Main.Location = new System.Drawing.Point(1, 1);
			this.UIWindow_Main.Name = "UIWindow_Main";
			this.UIWindow_Main.Size = new System.Drawing.Size(298, 298);
			this.UIWindow_Main.TabIndex = 0;
			// 
			// OverviewForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(300, 300);
			this.Controls.Add(this.UIWindow_Main);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Name = "OverviewForm";
			this.ShowInTaskbar = false;
			this.ResumeLayout(false);

		}
		#endregion
	}
}
