using System;
using JPGL.Common;
using JPGL.Common.Primitives;
using JPGL.Math;

namespace DrivingGame
{
	/// <summary>
	/// Summary description for Ramp.
	/// </summary>
	public class Ramp : SceneNode
	{
		private static Texture RampTexture = JPGL.OpenGL.GraphicsSystem.LoadTexture("stone006_color.jpg");
		private static Cube RampPimitive  = new Cube();
		
		//-----------------------------------//
		private Ode.BoxGeom m_RampGeom;
		//-----------------------------------//


		//-------------------------------------------------------------------------//
		public Ramp(
			float x, float y, float z, float w, float l,
			Ode.Space s) : base(RampPimitive, new Transform())
		{
			m_RampGeom = new Ode.BoxGeom(s, w, 1, l);

			P.Texture = RampTexture;

			T.S.X = w;
			T.S.Z = l;

			MoveTo(x, y, z);
		}

		//-------------------------------------------------------------------------//
		public void MoveTo(float x, float y, float z)
		{
			T.T.X = x;
			T.T.Y = y;
			T.T.Z = z;

			m_RampGeom.Position = new Ode.Vector3(x, y, z);
		}

		//-------------------------------------------------------------------------//
		public void SetRotation(Quaternion q)
		{
			T.RQ = q;

			Ode.Quaternion qode = new Ode.Quaternion();
			qode.X = q.X; qode.Y = q.Y; qode.Z = q.Z; qode.W = q.W;
			m_RampGeom.Quaternion = qode;
		}
	}
}
