using System;
using JPGL.Math;

namespace JPGL.Common.Colliders
{
	/// <summary>
	/// Summary description for ColliderRectangle.
	/// </summary>
	public class ColliderRectangle : Collider
	{
		//-----------------------------------//
		private ColliderClipPlane m_Right;
		private ColliderClipPlane m_Left;
		private ColliderClipPlane m_Top;
		private ColliderClipPlane m_Bottom;
		//-----------------------------------//

		//-----------------------------------//
		public override float Size
		{
			get { return 1; }
			set {  }
		}
		//-----------------------------------//


		//-------------------------------------------------------------------------//
		public ColliderRectangle(Vector3 pr, Vector3 nr, Vector3 pl, Vector3 nl,
								 Vector3 pt, Vector3 nt, Vector3 pb, Vector3 nb) : base(new Vector3())
		{

			this.m_Position.X = (pr.X + pl.X) / 2.0f;
			this.m_Position.Y = (pt.Y + pb.Y) / 2.0f;

			m_Right  = new ColliderClipPlane(pr, nr);
			m_Left   = new ColliderClipPlane(pl, nl);
			m_Top    = new ColliderClipPlane(pt, nt);
			m_Bottom = new ColliderClipPlane(pb, nb);
		}

		//-------------------------------------------------------------------------//
		public override Vector3 GetAdjustedPosition(Vector3 v)
		{
			Vector3 center = new Vector3();
			center.X = (m_Right.Position.X + m_Left.Position.X) / 2.0f;
			center.Y = (m_Top.Position.Y + m_Bottom.Position.Y) / 2.0f;

			return center;
		}

		//-------------------------------------------------------------------------//
		public override bool IsInCollider(Vector3 v)
		{
			if (m_Right.IsInCollider(v) && m_Left.IsInCollider(v) && 
				m_Top.IsInCollider(v) && m_Bottom.IsInCollider(v)) 
				return true;

			return false;
		}

		//-------------------------------------------------------------------------//
		public override Collider CollideWith(Collider other)
		{


			return this;
		}

		//-------------------------------------------------------------------------//
		protected override void Draw(JPGL.Common.Primitives.PrimitiveRenderer r)
		{
			
		}
	}
}
