using System;
using JPGL.Math;
using JPGL.Common.Primitives;
using JPGL.Common.SceneNodes;


namespace JPGL.Common.Lighting
{
	/// <summary>
	/// Summary description for DirectionalLight.
	/// </summary>
	public class DirectionalLight : Light
	{
		//-----------------------------------//
		public override int LightType
		{
			get
			{
				return Light.LIGHT_DIRECTIONAL;
			}
		}
		//-----------------------------------//


		//-------------------------------------------------------------------------//
		public DirectionalLight() : base()
		{
			m_DiffuseColor  = System.Drawing.Color.FromArgb(255, 25, 25, 25);
			m_AmbientColor  = System.Drawing.Color.FromArgb(255, 25, 25, 25);
			m_SpecularColor = System.Drawing.Color.FromArgb(255, 0, 0, 0);
		}

		//-------------------------------------------------------------------------//
		public override void DrawLight(PrimitiveRenderer r)
		{
			// Arrow
			Arrow dir   = new JPGL.Common.SceneNodes.Arrow();
			dir.T.T     = m_Position;
			dir.Lighted = false;
			dir.Color   = m_DiffuseColor;
			dir.T.RQ    = new Quaternion(
				(new Vector3(0, 1, 0).CrossProduct(m_Direction)).Normalize(), 
				(float)System.Math.Acos(new Vector3(0, 1, 0) * m_Direction) * (180.0f/(float)System.Math.PI));
	
			dir.DrawScene(r);
		}

	}
}
