using System;
using JPGL.Math;
using JPGL.Common.Primitives;


namespace JPGL.Common.Lighting
{
	/// <summary>
	/// Summary description for PointLight.
	/// </summary>
	public class PointLight : Light
	{
		//-----------------------------------//
		public override int LightType
		{
			get
			{
				return Light.LIGHT_POINT;
			}
		}
		//-----------------------------------//

		//-------------------------------------------------------------------------//
		public PointLight() : base()
		{
			m_DiffuseColor  = System.Drawing.Color.FromArgb(255, 204, 204, 204);
			m_AmbientColor  = System.Drawing.Color.FromArgb(255, 25, 25, 25);
			m_SpecularColor = System.Drawing.Color.FromArgb(255, 25, 25, 25);
		}

		//-------------------------------------------------------------------------//
		public override void DrawLight(PrimitiveRenderer r)
		{
			// Cone
			SceneNode c = new SceneNode(new Sphere(), new Transform());
			c.P.Lighted = false;
			c.P.Color  = m_DiffuseColor;
			c.T.S = new Vector3(0.25f, 0.25f, 0.25f);
			c.T.T = m_Position;

			c.DrawScene(r);
		}
	}
}
