using System;

namespace JPGL.Common.Primitives
{
	/// <summary>
	/// A FillablePrimitive is a shadable primitive that can also be filled
	/// in completely, not only drawn in point or wire modes.
	/// </summary>
	public abstract class FillablePrimitive : ShadablePrimitive
	{
		//-----------------------------------//
		protected bool       m_Filled;
		public override bool Filled
		{                                
			get { return m_Filled;  }         
			set { m_Filled = value; }
		}
		//-----------------------------------//


		//-------------------------------------------------------------------------//
		public FillablePrimitive() : base()
		{
			m_Filled = true;
		}

		//-------------------------------------------------------------------------//
		public FillablePrimitive(FillablePrimitive p) : base(p)
		{
			m_Filled = p.Filled;
		}
	}
}
