using System;

namespace JPGL.Common.Primitives
{
	/// <summary>
	/// A ShadablePrimitive is a 2 point DrawablePrimitive that can be shaded.
	/// </summary>
	public abstract class ShadablePrimitive : DrawablePrimitive2Point
	{
		//-----------------------------------//
		protected bool       m_Shaded;       // 
		public override bool Shaded          //
		{
			get { return m_Shaded;  }
			set { m_Shaded = value; GenColorArray(); }
		}
		//-----------------------------------//

		//-------------------------------------------------------------------------//
		public ShadablePrimitive() : base()
		{
			m_Shaded = true;
		}

		//-------------------------------------------------------------------------//
		public ShadablePrimitive(ShadablePrimitive p) : base(p)
		{
			m_Shaded = p.Shaded;
		}
	}
}
