using System;
using JPGL.Common.Colliders;
using JPGL.Math;

namespace JPGL.Common.Primitives
{
	/// <summary>
	/// Circle4Collider is a Circle that simply has 4 colliders instead of 1.
	/// </summary>
	public class Circle4Collider : Circle
	{
		//-------------------------------------------------------------------------//
		public override ColliderList GetColliders()
		{
			if (!Defined) return null;

			float cRadius = m_Radius / 2.0f;

			ColliderList c  = new ColliderList();
			c.AddCollider(new ColliderCircle(m_Points[0] + new Vector3(cRadius, cRadius, 0.0f), cRadius));
			c.AddCollider(new ColliderCircle(m_Points[0] + new Vector3(-1.0f*cRadius, cRadius, 0.0f), cRadius));
			c.AddCollider(new ColliderCircle(m_Points[0] + new Vector3(-1.0f*cRadius, -1.0f*cRadius, 0.0f), cRadius));
			c.AddCollider(new ColliderCircle(m_Points[0] + new Vector3(cRadius, -1.0f*cRadius, 0.0f), cRadius));

			return c;
		}
	}
}
