using System;
using JPGL.Common.Colliders;
using JPGL.Math;

namespace JPGL.Common.Primitives
{
	/// <summary>
	/// Summary description for Cube.
	/// </summary>
	public class Cube : FillablePrimitive
	{
		//-----------------------------------// 
		public override bool Defined
		{
			get
			{
				return true;
			}
		}
		//-----------------------------------//

		//-------------------------------------------------------------------------//
		public override ColliderList GetColliders()
		{
			if (!Defined) return null;

			ColliderList c = new ColliderList();
			c.AddCollider(new ColliderCircle(new Vector3(0, 0, 0), 0.5f));

			return c;
		}

		//-------------------------------------------------------------------------//
		// Square of side length 1, centered at origin.
		public override Geometry GetGeometry()
		{
			return Geometry.CubeGeometry;
		}

		//-------------------------------------------------------------------------//
		public override Transform GetTransform()
		{
			return new Transform();
		}
	}
}
