using System;
using JPGL.Common.Colliders;
using JPGL.Math;

namespace JPGL.Common.Primitives
{
	/// <summary>
	/// A Point is a single point. A Point has a ColliderCircle with radius
	/// equal to the half the pointsize.
	/// </summary>
	public class Point : DrawablePrimitive1Point
	{
		//-------------------------------------------------------------------------//
		// Point at the origin.
		public override Geometry GetGeometry()
		{
			return Geometry.PointGeometry;
		}

		//-------------------------------------------------------------------------//
		public override Transform GetTransform()
		{
			return new Transform(new Vector3(1.0f, 1.0f, 1.0f), new Vector3(0, 0, 0), m_Points[0]);
		}

		//-------------------------------------------------------------------------//
		public override ColliderList GetColliders()
		{
			if (!Defined) return null;

			return new ColliderList(new ColliderCircle(m_Points[0], m_PointSize*0.5f));
		}
	}
}
