using System;
using JPGL.Math;


namespace JPGL.Common.Primitives
{
	/// <summary>
	/// Summary description for Sphere.
	/// </summary>
	public class Sphere : Circle
	{
		//-------------------------------------------------------------------------//
		public Sphere() : base()
		{

		}

		//-------------------------------------------------------------------------//
		// Geometry for a unit circle centered at (0,0).
		public override Geometry GetGeometry()
		{
			return Geometry.SphereGeometry;
		}

		//-------------------------------------------------------------------------//
		public override Transform GetTransform()
		{
			return new Transform(new Vector3(m_Radius, m_Radius, m_Radius), new Vector3(0, 0, 0), m_Points[0]);
		}
	}
}
