using System;
using JPGL.Common;
using JPGL.Common.Primitives;
using JPGL.Math;

namespace JPGL.Common.SceneNodes
{
	/// <summary>
	/// Summary description for Arrow.
	/// </summary>
	public class Arrow : SceneNode
	{
		//-----------------------------------//
		public static int CYLINDERGEOMETRY = Geometry.LoadOBJ("cylinder.obj");
		public static int CONEGEOMETRY     = Geometry.LoadOBJ("cone.obj");
		//-----------------------------------//

		//-----------------------------------//
		private SceneNode m_Body;
		private SceneNode m_Head;
		//-----------------------------------//

		//-----------------------------------//
		public System.Drawing.Color Color
		{
			get { return m_Body.P.Color;  }
			set 
			{ 
				m_Body.P.Color = value;
				m_Head.P.Color = value;
			}
		}
		//-----------------------------------//

		//-----------------------------------//
		public bool Lighted
		{
			get { return m_Body.P.Lighted;  }
			set 
			{ 
				m_Body.P.Lighted = value;
				m_Head.P.Lighted = value;
			}
		}
		//-----------------------------------//

		//-----------------------------------//
		public bool Visible
		{
			get { return m_Body.P.Visibility; }
			set
			{
				m_Body.P.Visibility = value;
				m_Head.P.Visibility = value;
			}
		}
		//-----------------------------------//


		//-------------------------------------------------------------------------//
		public Arrow() : base(null, new Transform())
		{
			// Body of the arrow
			m_Body = new SceneNode(new LoadedPrimitive(CYLINDERGEOMETRY), new Transform());
			m_Body.T.S = new Vector3(0.025f, 0.025f, 0.5f);
			m_Body.T.RXBy = 90;
			m_Body.T.T = new Vector3(0, 0.75f, 0);
			m_Body.P.Color = System.Drawing.Color.Red;
			AddChild(m_Body);

			// Head of the arrow
			m_Head = new SceneNode(new LoadedPrimitive(CONEGEOMETRY), new Transform());
			m_Head.T.S = new Vector3(0.08f, 0.08f, 0.08f);
			m_Head.T.RXBy = 90;
			m_Head.T.T = new Vector3(0, 1.48f, 0);
			m_Head.P.Color = System.Drawing.Color.Red;
			AddChild(m_Head);
		}
	}
}
